Index: /GTP/trunk/Lib/Vis/Preprocessing/src/RayCaster.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/RayCaster.h	(revision 2076)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/RayCaster.h	(revision 2077)
@@ -66,5 +66,6 @@
 						const bool castDoubleRay,
 						const bool pruneInvalidRays = true);
-	/*virtual void CastRaysEye4(SimpleRayContainer &rays,
+
+  /*virtual void CastRaysEye4(SimpleRayContainer &rays,
 							  VssRayContainer &vssRays,
 							  const AxisAlignedBox3 &sbox,
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.vcproj
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.vcproj	(revision 2073)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.vcproj	(revision 2077)
@@ -2,12 +2,16 @@
 <VisualStudioProject
 	ProjectType="Visual C++"
-	Version="7.10"
+	Version="8.00"
 	Name="Preprocessor"
 	ProjectGUID="{EABCE292-D598-4600-A1C9-2591E7D62FDA}"
-	Keyword="Win32Proj">
+	Keyword="Win32Proj"
+	>
 	<Platforms>
 		<Platform
-			Name="Win32"/>
+			Name="Win32"
+		/>
 	</Platforms>
+	<ToolFiles>
+	</ToolFiles>
 	<Configurations>
 		<Configuration
@@ -16,5 +20,22 @@
 			IntermediateDirectory="..\obj\$(ConfigurationName)"
 			ConfigurationType="4"
-			CharacterSet="2">
+			InheritedPropertySheets="$(VCInstallDir)VCProjectDefaults\UpgradeFromVC71.vsprops"
+			CharacterSet="2"
+			>
+			<Tool
+				Name="VCPreBuildEventTool"
+			/>
+			<Tool
+				Name="VCCustomBuildTool"
+			/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"
+			/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"
+			/>
+			<Tool
+				Name="VCMIDLTool"
+			/>
 			<Tool
 				Name="VCCLCompilerTool"
@@ -22,35 +43,41 @@
 				AdditionalIncludeDirectories="..\include;..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;..\..\..\..\..\..\NonGTP\Boost"
 				PreprocessorDefinitions="WIN32;_DEBUG;_LIB;"
-				MinimalRebuild="TRUE"
+				MinimalRebuild="true"
 				BasicRuntimeChecks="3"
 				RuntimeLibrary="3"
-				RuntimeTypeInfo="TRUE"
+				RuntimeTypeInfo="true"
 				UsePrecompiledHeader="0"
 				BrowseInformation="1"
 				WarningLevel="3"
-				Detect64BitPortabilityProblems="TRUE"
-				DebugInformationFormat="3"/>
-			<Tool
-				Name="VCCustomBuildTool"/>
-			<Tool
-				Name="VCLibrarianTool"/>
-			<Tool
-				Name="VCMIDLTool"/>
-			<Tool
-				Name="VCPostBuildEventTool"/>
-			<Tool
-				Name="VCPreBuildEventTool"/>
-			<Tool
-				Name="VCPreLinkEventTool"/>
-			<Tool
-				Name="VCResourceCompilerTool"/>
-			<Tool
-				Name="VCWebServiceProxyGeneratorTool"/>
-			<Tool
-				Name="VCXMLDataGeneratorTool"/>
-			<Tool
-				Name="VCManagedWrapperGeneratorTool"/>
-			<Tool
-				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
+				Detect64BitPortabilityProblems="true"
+				DebugInformationFormat="3"
+			/>
+			<Tool
+				Name="VCManagedResourceCompilerTool"
+			/>
+			<Tool
+				Name="VCResourceCompilerTool"
+			/>
+			<Tool
+				Name="VCPreLinkEventTool"
+			/>
+			<Tool
+				Name="VCLibrarianTool"
+			/>
+			<Tool
+				Name="VCALinkTool"
+			/>
+			<Tool
+				Name="VCXDCMakeTool"
+			/>
+			<Tool
+				Name="VCBscMakeTool"
+			/>
+			<Tool
+				Name="VCFxCopTool"
+			/>
+			<Tool
+				Name="VCPostBuildEventTool"
+			/>
 		</Configuration>
 		<Configuration
@@ -59,50 +86,70 @@
 			IntermediateDirectory="..\obj\$(ConfigurationName)"
 			ConfigurationType="4"
-			CharacterSet="2">
+			InheritedPropertySheets="$(VCInstallDir)VCProjectDefaults\UpgradeFromVC71.vsprops"
+			CharacterSet="2"
+			>
+			<Tool
+				Name="VCPreBuildEventTool"
+			/>
+			<Tool
+				Name="VCCustomBuildTool"
+			/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"
+			/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"
+			/>
+			<Tool
+				Name="VCMIDLTool"
+			/>
 			<Tool
 				Name="VCCLCompilerTool"
 				Optimization="3"
-				GlobalOptimizations="TRUE"
 				InlineFunctionExpansion="2"
-				EnableIntrinsicFunctions="TRUE"
+				EnableIntrinsicFunctions="true"
 				FavorSizeOrSpeed="1"
-				OmitFramePointers="TRUE"
-				EnableFiberSafeOptimizations="TRUE"
-				OptimizeForProcessor="0"
-				OptimizeForWindowsApplication="TRUE"
+				OmitFramePointers="true"
+				EnableFiberSafeOptimizations="true"
 				AdditionalIncludeDirectories="..\include;..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;..\..\..\..\..\..\NonGTP\Boost;Timer"
 				PreprocessorDefinitions="WIN32;NDEBUG;_LIB"
-				ExceptionHandling="TRUE"
+				ExceptionHandling="1"
 				RuntimeLibrary="2"
-				DisableLanguageExtensions="FALSE"
-				ForceConformanceInForLoopScope="FALSE"
-				RuntimeTypeInfo="FALSE"
+				DisableLanguageExtensions="false"
+				ForceConformanceInForLoopScope="false"
+				RuntimeTypeInfo="false"
 				UsePrecompiledHeader="0"
 				BrowseInformation="1"
 				WarningLevel="2"
-				Detect64BitPortabilityProblems="TRUE"
-				DebugInformationFormat="3"/>
-			<Tool
-				Name="VCCustomBuildTool"/>
-			<Tool
-				Name="VCLibrarianTool"/>
-			<Tool
-				Name="VCMIDLTool"/>
-			<Tool
-				Name="VCPostBuildEventTool"/>
-			<Tool
-				Name="VCPreBuildEventTool"/>
-			<Tool
-				Name="VCPreLinkEventTool"/>
-			<Tool
-				Name="VCResourceCompilerTool"/>
-			<Tool
-				Name="VCWebServiceProxyGeneratorTool"/>
-			<Tool
-				Name="VCXMLDataGeneratorTool"/>
-			<Tool
-				Name="VCManagedWrapperGeneratorTool"/>
-			<Tool
-				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
+				Detect64BitPortabilityProblems="true"
+				DebugInformationFormat="3"
+			/>
+			<Tool
+				Name="VCManagedResourceCompilerTool"
+			/>
+			<Tool
+				Name="VCResourceCompilerTool"
+			/>
+			<Tool
+				Name="VCPreLinkEventTool"
+			/>
+			<Tool
+				Name="VCLibrarianTool"
+			/>
+			<Tool
+				Name="VCALinkTool"
+			/>
+			<Tool
+				Name="VCXDCMakeTool"
+			/>
+			<Tool
+				Name="VCBscMakeTool"
+			/>
+			<Tool
+				Name="VCFxCopTool"
+			/>
+			<Tool
+				Name="VCPostBuildEventTool"
+			/>
 		</Configuration>
 		<Configuration
@@ -111,50 +158,70 @@
 			IntermediateDirectory="$(ConfigurationName)"
 			ConfigurationType="4"
-			CharacterSet="2">
+			InheritedPropertySheets="$(VCInstallDir)VCProjectDefaults\UpgradeFromVC71.vsprops"
+			CharacterSet="2"
+			>
+			<Tool
+				Name="VCPreBuildEventTool"
+			/>
+			<Tool
+				Name="VCCustomBuildTool"
+			/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"
+			/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"
+			/>
+			<Tool
+				Name="VCMIDLTool"
+			/>
 			<Tool
 				Name="VCCLCompilerTool"
 				Optimization="2"
-				GlobalOptimizations="FALSE"
 				InlineFunctionExpansion="0"
-				EnableIntrinsicFunctions="FALSE"
+				EnableIntrinsicFunctions="false"
 				FavorSizeOrSpeed="1"
-				OmitFramePointers="FALSE"
-				EnableFiberSafeOptimizations="FALSE"
-				OptimizeForProcessor="3"
-				OptimizeForWindowsApplication="TRUE"
+				OmitFramePointers="false"
+				EnableFiberSafeOptimizations="false"
 				AdditionalIncludeDirectories="..\include;&quot;$(QTDIR)\include\QtCore&quot;;&quot;$(QTDIR)\include\QtGui&quot;;&quot;$(QTDIR)\include&quot;;&quot;$(QTDIR)\include\QtOpenGl&quot;;..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;..\..\..\..\..\..\NonGTP\Boost;..\..\Preprocessing\MultiLevelRayTracing"
 				PreprocessorDefinitions="WIN32;NDEBUG;_LIB;GTP_INTERNAL"
-				MinimalRebuild="TRUE"
-				ExceptionHandling="TRUE"
+				MinimalRebuild="true"
+				ExceptionHandling="1"
 				RuntimeLibrary="2"
-				DisableLanguageExtensions="FALSE"
-				ForceConformanceInForLoopScope="FALSE"
-				RuntimeTypeInfo="TRUE"
+				DisableLanguageExtensions="false"
+				ForceConformanceInForLoopScope="false"
+				RuntimeTypeInfo="true"
 				UsePrecompiledHeader="0"
 				WarningLevel="2"
-				Detect64BitPortabilityProblems="TRUE"
-				DebugInformationFormat="3"/>
-			<Tool
-				Name="VCCustomBuildTool"/>
-			<Tool
-				Name="VCLibrarianTool"/>
-			<Tool
-				Name="VCMIDLTool"/>
-			<Tool
-				Name="VCPostBuildEventTool"/>
-			<Tool
-				Name="VCPreBuildEventTool"/>
-			<Tool
-				Name="VCPreLinkEventTool"/>
-			<Tool
-				Name="VCResourceCompilerTool"/>
-			<Tool
-				Name="VCWebServiceProxyGeneratorTool"/>
-			<Tool
-				Name="VCXMLDataGeneratorTool"/>
-			<Tool
-				Name="VCManagedWrapperGeneratorTool"/>
-			<Tool
-				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
+				Detect64BitPortabilityProblems="true"
+				DebugInformationFormat="3"
+			/>
+			<Tool
+				Name="VCManagedResourceCompilerTool"
+			/>
+			<Tool
+				Name="VCResourceCompilerTool"
+			/>
+			<Tool
+				Name="VCPreLinkEventTool"
+			/>
+			<Tool
+				Name="VCLibrarianTool"
+			/>
+			<Tool
+				Name="VCALinkTool"
+			/>
+			<Tool
+				Name="VCXDCMakeTool"
+			/>
+			<Tool
+				Name="VCBscMakeTool"
+			/>
+			<Tool
+				Name="VCFxCopTool"
+			/>
+			<Tool
+				Name="VCPostBuildEventTool"
+			/>
 		</Configuration>
 		<Configuration
@@ -163,5 +230,22 @@
 			IntermediateDirectory="$(ConfigurationName)"
 			ConfigurationType="4"
-			CharacterSet="2">
+			InheritedPropertySheets="$(VCInstallDir)VCProjectDefaults\UpgradeFromVC71.vsprops"
+			CharacterSet="2"
+			>
+			<Tool
+				Name="VCPreBuildEventTool"
+			/>
+			<Tool
+				Name="VCCustomBuildTool"
+			/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"
+			/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"
+			/>
+			<Tool
+				Name="VCMIDLTool"
+			/>
 			<Tool
 				Name="VCCLCompilerTool"
@@ -169,38 +253,43 @@
 				InlineFunctionExpansion="0"
 				FavorSizeOrSpeed="0"
-				OptimizeForWindowsApplication="TRUE"
 				AdditionalIncludeDirectories="..\include;&quot;$(QTDIR)\include\QtCore&quot;;&quot;$(QTDIR)\include\QtGui&quot;;&quot;$(QTDIR)\include&quot;;&quot;$(QTDIR)\include\QtOpenGl&quot;;..\src;&quot;$(CG_INC_PATH)&quot;;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;&quot;$(BOOST_INCLUDE)&quot;;..\..\Preprocessing\MultiLevelRayTracing"
 				PreprocessorDefinitions="WIN32;NDEBUG;_LIB"
-				ExceptionHandling="TRUE"
+				ExceptionHandling="1"
 				RuntimeLibrary="2"
-				DisableLanguageExtensions="FALSE"
-				ForceConformanceInForLoopScope="FALSE"
-				RuntimeTypeInfo="TRUE"
+				DisableLanguageExtensions="false"
+				ForceConformanceInForLoopScope="false"
+				RuntimeTypeInfo="true"
 				UsePrecompiledHeader="0"
 				WarningLevel="2"
-				Detect64BitPortabilityProblems="TRUE"
-				DebugInformationFormat="3"/>
-			<Tool
-				Name="VCCustomBuildTool"/>
-			<Tool
-				Name="VCLibrarianTool"/>
-			<Tool
-				Name="VCMIDLTool"/>
-			<Tool
-				Name="VCPostBuildEventTool"/>
-			<Tool
-				Name="VCPreBuildEventTool"/>
-			<Tool
-				Name="VCPreLinkEventTool"/>
-			<Tool
-				Name="VCResourceCompilerTool"/>
-			<Tool
-				Name="VCWebServiceProxyGeneratorTool"/>
-			<Tool
-				Name="VCXMLDataGeneratorTool"/>
-			<Tool
-				Name="VCManagedWrapperGeneratorTool"/>
-			<Tool
-				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
+				Detect64BitPortabilityProblems="true"
+				DebugInformationFormat="3"
+			/>
+			<Tool
+				Name="VCManagedResourceCompilerTool"
+			/>
+			<Tool
+				Name="VCResourceCompilerTool"
+			/>
+			<Tool
+				Name="VCPreLinkEventTool"
+			/>
+			<Tool
+				Name="VCLibrarianTool"
+			/>
+			<Tool
+				Name="VCALinkTool"
+			/>
+			<Tool
+				Name="VCXDCMakeTool"
+			/>
+			<Tool
+				Name="VCBscMakeTool"
+			/>
+			<Tool
+				Name="VCFxCopTool"
+			/>
+			<Tool
+				Name="VCPostBuildEventTool"
+			/>
 		</Configuration>
 		<Configuration
@@ -209,52 +298,72 @@
 			IntermediateDirectory="$(ConfigurationName)"
 			ConfigurationType="4"
-			CharacterSet="2">
+			InheritedPropertySheets="$(VCInstallDir)VCProjectDefaults\UpgradeFromVC71.vsprops"
+			CharacterSet="2"
+			>
+			<Tool
+				Name="VCPreBuildEventTool"
+			/>
+			<Tool
+				Name="VCCustomBuildTool"
+			/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"
+			/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"
+			/>
+			<Tool
+				Name="VCMIDLTool"
+			/>
 			<Tool
 				Name="VCCLCompilerTool"
 				Optimization="3"
-				GlobalOptimizations="TRUE"
 				InlineFunctionExpansion="0"
-				EnableIntrinsicFunctions="TRUE"
+				EnableIntrinsicFunctions="true"
 				FavorSizeOrSpeed="1"
-				OmitFramePointers="TRUE"
-				EnableFiberSafeOptimizations="TRUE"
-				OptimizeForProcessor="3"
-				OptimizeForWindowsApplication="TRUE"
+				OmitFramePointers="true"
+				EnableFiberSafeOptimizations="true"
 				AdditionalIncludeDirectories="..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;..\..\..\..\..\..\NonGTP\Boost;..\MultiLevelRayTracing;&quot;$(QTDIR)\include\QtCore&quot;;&quot;$(QTDIR)\include\QtGui&quot;;&quot;$(QTDIR)\include&quot;;&quot;$(QTDIR)\include\QtOpenGl&quot;;&quot;$(CG_INC_PATH)&quot;;Timer"
 				PreprocessorDefinitions="WIN32;NDEBUG;_LIB;GTP_INTERNAL;USE_QT"
-				ExceptionHandling="TRUE"
+				ExceptionHandling="1"
 				RuntimeLibrary="2"
 				EnableEnhancedInstructionSet="2"
-				DisableLanguageExtensions="FALSE"
-				ForceConformanceInForLoopScope="FALSE"
-				RuntimeTypeInfo="FALSE"
+				DisableLanguageExtensions="false"
+				ForceConformanceInForLoopScope="false"
+				RuntimeTypeInfo="false"
 				UsePrecompiledHeader="0"
 				BrowseInformation="1"
 				WarningLevel="2"
-				Detect64BitPortabilityProblems="TRUE"
-				DebugInformationFormat="3"/>
-			<Tool
-				Name="VCCustomBuildTool"/>
+				Detect64BitPortabilityProblems="true"
+				DebugInformationFormat="3"
+			/>
+			<Tool
+				Name="VCManagedResourceCompilerTool"
+			/>
+			<Tool
+				Name="VCResourceCompilerTool"
+			/>
+			<Tool
+				Name="VCPreLinkEventTool"
+			/>
 			<Tool
 				Name="VCLibrarianTool"
-				OutputFile="../lib/Release/$(ProjectName).lib"/>
-			<Tool
-				Name="VCMIDLTool"/>
-			<Tool
-				Name="VCPostBuildEventTool"/>
-			<Tool
-				Name="VCPreBuildEventTool"/>
-			<Tool
-				Name="VCPreLinkEventTool"/>
-			<Tool
-				Name="VCResourceCompilerTool"/>
-			<Tool
-				Name="VCWebServiceProxyGeneratorTool"/>
-			<Tool
-				Name="VCXMLDataGeneratorTool"/>
-			<Tool
-				Name="VCManagedWrapperGeneratorTool"/>
-			<Tool
-				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
+				OutputFile="../lib/Release/$(ProjectName).lib"
+			/>
+			<Tool
+				Name="VCALinkTool"
+			/>
+			<Tool
+				Name="VCXDCMakeTool"
+			/>
+			<Tool
+				Name="VCBscMakeTool"
+			/>
+			<Tool
+				Name="VCFxCopTool"
+			/>
+			<Tool
+				Name="VCPostBuildEventTool"
+			/>
 		</Configuration>
 		<Configuration
@@ -263,5 +372,22 @@
 			IntermediateDirectory="$(ConfigurationName)"
 			ConfigurationType="4"
-			CharacterSet="2">
+			InheritedPropertySheets="$(VCInstallDir)VCProjectDefaults\UpgradeFromVC71.vsprops"
+			CharacterSet="2"
+			>
+			<Tool
+				Name="VCPreBuildEventTool"
+			/>
+			<Tool
+				Name="VCCustomBuildTool"
+			/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"
+			/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"
+			/>
+			<Tool
+				Name="VCMIDLTool"
+			/>
 			<Tool
 				Name="VCCLCompilerTool"
@@ -269,41 +395,45 @@
 				InlineFunctionExpansion="0"
 				FavorSizeOrSpeed="0"
-				OptimizeForProcessor="3"
-				OptimizeForWindowsApplication="TRUE"
 				AdditionalIncludeDirectories="..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;..\..\..\..\..\..\NonGTP\Boost;..\MultiLevelRayTracing;&quot;$(QTDIR)\include\QtCore&quot;;&quot;$(QTDIR)\include\QtGui&quot;;&quot;$(QTDIR)\include&quot;"
 				PreprocessorDefinitions="WIN32;NDEBUG;_LIB;GTP_INTERNAL;NO_QT"
-				ExceptionHandling="TRUE"
+				ExceptionHandling="1"
 				RuntimeLibrary="2"
-				DisableLanguageExtensions="FALSE"
-				ForceConformanceInForLoopScope="FALSE"
-				RuntimeTypeInfo="TRUE"
+				DisableLanguageExtensions="false"
+				ForceConformanceInForLoopScope="false"
+				RuntimeTypeInfo="true"
 				UsePrecompiledHeader="0"
 				BrowseInformation="1"
 				WarningLevel="2"
-				Detect64BitPortabilityProblems="TRUE"
-				DebugInformationFormat="3"/>
-			<Tool
-				Name="VCCustomBuildTool"/>
+				Detect64BitPortabilityProblems="true"
+				DebugInformationFormat="3"
+			/>
+			<Tool
+				Name="VCManagedResourceCompilerTool"
+			/>
+			<Tool
+				Name="VCResourceCompilerTool"
+			/>
+			<Tool
+				Name="VCPreLinkEventTool"
+			/>
 			<Tool
 				Name="VCLibrarianTool"
-				OutputFile="../lib/Release/$(ProjectName).lib"/>
-			<Tool
-				Name="VCMIDLTool"/>
-			<Tool
-				Name="VCPostBuildEventTool"/>
-			<Tool
-				Name="VCPreBuildEventTool"/>
-			<Tool
-				Name="VCPreLinkEventTool"/>
-			<Tool
-				Name="VCResourceCompilerTool"/>
-			<Tool
-				Name="VCWebServiceProxyGeneratorTool"/>
-			<Tool
-				Name="VCXMLDataGeneratorTool"/>
-			<Tool
-				Name="VCManagedWrapperGeneratorTool"/>
-			<Tool
-				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
+				OutputFile="../lib/Release/$(ProjectName).lib"
+			/>
+			<Tool
+				Name="VCALinkTool"
+			/>
+			<Tool
+				Name="VCXDCMakeTool"
+			/>
+			<Tool
+				Name="VCBscMakeTool"
+			/>
+			<Tool
+				Name="VCFxCopTool"
+			/>
+			<Tool
+				Name="VCPostBuildEventTool"
+			/>
 		</Configuration>
 		<Configuration
@@ -312,5 +442,22 @@
 			IntermediateDirectory="$(ConfigurationName)"
 			ConfigurationType="4"
-			CharacterSet="2">
+			InheritedPropertySheets="$(VCInstallDir)VCProjectDefaults\UpgradeFromVC71.vsprops"
+			CharacterSet="2"
+			>
+			<Tool
+				Name="VCPreBuildEventTool"
+			/>
+			<Tool
+				Name="VCCustomBuildTool"
+			/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"
+			/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"
+			/>
+			<Tool
+				Name="VCMIDLTool"
+			/>
 			<Tool
 				Name="VCCLCompilerTool"
@@ -318,41 +465,45 @@
 				InlineFunctionExpansion="0"
 				FavorSizeOrSpeed="0"
-				OptimizeForProcessor="3"
-				OptimizeForWindowsApplication="TRUE"
 				AdditionalIncludeDirectories="..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;..\..\..\..\..\..\NonGTP\Boost;..\MultiLevelRayTracing;&quot;$(QTDIR)\include\QtCore&quot;;&quot;$(QTDIR)\include\QtGui&quot;;&quot;$(QTDIR)\include&quot;;&quot;$(QTDIR)\include\QtOpenGl&quot;;&quot;$(CG_INC_PATH)&quot;;Timer"
 				PreprocessorDefinitions="WIN32;NDEBUG;_LIB;USE_QT;ATI"
-				ExceptionHandling="TRUE"
+				ExceptionHandling="1"
 				RuntimeLibrary="2"
-				DisableLanguageExtensions="FALSE"
-				ForceConformanceInForLoopScope="FALSE"
-				RuntimeTypeInfo="TRUE"
+				DisableLanguageExtensions="false"
+				ForceConformanceInForLoopScope="false"
+				RuntimeTypeInfo="true"
 				UsePrecompiledHeader="0"
 				BrowseInformation="1"
 				WarningLevel="2"
-				Detect64BitPortabilityProblems="TRUE"
-				DebugInformationFormat="3"/>
-			<Tool
-				Name="VCCustomBuildTool"/>
+				Detect64BitPortabilityProblems="true"
+				DebugInformationFormat="3"
+			/>
+			<Tool
+				Name="VCManagedResourceCompilerTool"
+			/>
+			<Tool
+				Name="VCResourceCompilerTool"
+			/>
+			<Tool
+				Name="VCPreLinkEventTool"
+			/>
 			<Tool
 				Name="VCLibrarianTool"
-				OutputFile="../lib/Release/$(ProjectName).lib"/>
-			<Tool
-				Name="VCMIDLTool"/>
-			<Tool
-				Name="VCPostBuildEventTool"/>
-			<Tool
-				Name="VCPreBuildEventTool"/>
-			<Tool
-				Name="VCPreLinkEventTool"/>
-			<Tool
-				Name="VCResourceCompilerTool"/>
-			<Tool
-				Name="VCWebServiceProxyGeneratorTool"/>
-			<Tool
-				Name="VCXMLDataGeneratorTool"/>
-			<Tool
-				Name="VCManagedWrapperGeneratorTool"/>
-			<Tool
-				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
+				OutputFile="../lib/Release/$(ProjectName).lib"
+			/>
+			<Tool
+				Name="VCALinkTool"
+			/>
+			<Tool
+				Name="VCXDCMakeTool"
+			/>
+			<Tool
+				Name="VCBscMakeTool"
+			/>
+			<Tool
+				Name="VCFxCopTool"
+			/>
+			<Tool
+				Name="VCPostBuildEventTool"
+			/>
 		</Configuration>
 	</Configurations>
@@ -363,592 +514,781 @@
 			Name="Source Files"
 			Filter="cpp;c;cxx;def;odl;idl;hpj;bat;asm;asmx"
-			UniqueIdentifier="{4FC737F1-C7A5-4376-A066-2A32D752A2FF}">
-			<File
-				RelativePath="..\src\AxisAlignedBox3.cpp">
-			</File>
-			<File
-				RelativePath="..\src\AxisAlignedBox3.h">
-			</File>
-			<File
-				RelativePath="..\src\Beam.cpp">
-			</File>
-			<File
-				RelativePath="..\src\Beam.h">
-			</File>
-			<File
-				RelativePath=".\Timer\BenchTimer.cpp">
-			</File>
-			<File
-				RelativePath=".\Timer\BenchTimer.h">
-			</File>
-			<File
-				RelativePath="..\src\BoostPreprocessorThread.cpp">
-			</File>
-			<File
-				RelativePath="..\src\BoostPreprocessorThread.h">
-			</File>
-			<File
-				RelativePath="..\src\BoundingBoxConverter.h">
-			</File>
-			<File
-				RelativePath=".\BvHierarchy.cpp">
-			</File>
-			<File
-				RelativePath=".\BvHierarchy.h">
-			</File>
-			<File
-				RelativePath="..\src\Camera.cpp">
-			</File>
-			<File
-				RelativePath="..\src\Camera.h">
-			</File>
-			<File
-				RelativePath=".\CombinedPreprocessor.cpp">
-			</File>
-			<File
-				RelativePath=".\CombinedPreprocessor.h">
-			</File>
-			<File
-				RelativePath="..\src\common.cpp">
-			</File>
-			<File
-				RelativePath="..\src\common.h">
-			</File>
-			<File
-				RelativePath="..\src\Containers.h">
-			</File>
-			<File
-				RelativePath="..\src\dual_depth.cg">
-			</File>
-			<File
-				RelativePath="..\src\Environment.cpp">
-			</File>
-			<File
-				RelativePath="..\src\Environment.h">
-			</File>
-			<File
-				RelativePath="..\src\ExactPreprocessor.cpp">
-			</File>
-			<File
-				RelativePath="..\src\ExactPreprocessor.h">
-			</File>
-			<File
-				RelativePath="..\src\Exporter.cpp">
-			</File>
-			<File
-				RelativePath="..\src\Exporter.h">
-			</File>
-			<File
-				RelativePath="..\src\FlexibleHeap.h">
-			</File>
-			<File
-				RelativePath="..\src\glInterface.h">
-			</File>
-			<File
-				RelativePath=".\GlobalLinesRenderer.cpp">
-			</File>
-			<File
-				RelativePath=".\GlobalLinesRenderer.h">
-			</File>
-			<File
-				RelativePath=".\GvsPreprocessor.cpp">
-			</File>
-			<File
-				RelativePath=".\GvsPreprocessor.h">
-			</File>
-			<File
-				RelativePath="..\src\GzBinFileInputStream.cpp">
-			</File>
-			<File
-				RelativePath="..\src\GzBinFileInputStream.h">
-			</File>
-			<File
-				RelativePath="..\src\GzFileInputSource.cpp">
-			</File>
-			<File
-				RelativePath="..\src\GzFileInputSource.h">
-			</File>
-			<File
-				RelativePath="..\src\gzstream.cpp">
-			</File>
-			<File
-				RelativePath="..\src\gzstream.h">
-			</File>
-			<File
-				RelativePath="..\src\Halton.cpp">
-			</File>
-			<File
-				RelativePath="..\src\Halton.h">
-			</File>
-			<File
-				RelativePath=".\HierarchyManager.cpp">
-			</File>
-			<File
-				RelativePath=".\HierarchyManager.h">
-			</File>
-			<File
-				RelativePath=".\IntelRayCaster.cpp">
-			</File>
-			<File
-				RelativePath=".\IntelRayCaster.h">
-			</File>
-			<File
-				RelativePath=".\InternalRayCaster.cpp">
-			</File>
-			<File
-				RelativePath=".\InternalRayCaster.h">
-			</File>
-			<File
-				RelativePath=".\Intersectable.cpp">
-			</File>
-			<File
-				RelativePath=".\Intersectable.h">
-			</File>
-			<File
-				RelativePath=".\IntersectableWrapper.cpp">
-			</File>
-			<File
-				RelativePath=".\IntersectableWrapper.h">
-			</File>
-			<File
-				RelativePath="..\src\KdTree.cpp">
-			</File>
-			<File
-				RelativePath="..\src\KdTree.h">
-			</File>
-			<File
-				RelativePath="..\src\LogManager.cpp">
-			</File>
-			<File
-				RelativePath="..\src\LogManager.h">
-			</File>
-			<File
-				RelativePath="..\src\Material.cpp">
-			</File>
-			<File
-				RelativePath="..\src\Material.h">
-			</File>
-			<File
-				RelativePath="..\src\Matrix4x4.cpp">
-			</File>
-			<File
-				RelativePath="..\src\Matrix4x4.h">
-			</File>
-			<File
-				RelativePath=".\Timer\merror.cpp">
-			</File>
-			<File
-				RelativePath=".\Timer\merror.h">
-			</File>
-			<File
-				RelativePath="..\src\Mesh.cpp">
-			</File>
-			<File
-				RelativePath="..\src\Mesh.h">
-			</File>
-			<File
-				RelativePath="..\src\MeshKdTree.cpp">
-			</File>
-			<File
-				RelativePath="..\src\MeshKdTree.h">
-			</File>
-			<File
-				RelativePath=".\Timer\mstring.h">
-			</File>
-			<File
-				RelativePath=".\Mutation.cpp">
-			</File>
-			<File
-				RelativePath=".\Mutation.h">
-			</File>
-			<File
-				RelativePath="..\src\MutualVisibility.cpp">
-			</File>
-			<File
-				RelativePath="..\src\MutualVisibility.h">
-			</File>
-			<File
-				RelativePath=".\ObjExporter.cpp">
-			</File>
-			<File
-				RelativePath=".\ObjExporter.h">
-			</File>
-			<File
-				RelativePath="..\src\ObjParser.cpp">
-			</File>
-			<File
-				RelativePath="..\src\ObjParser.h">
-			</File>
-			<File
-				RelativePath="..\src\OcclusionQuery.cpp">
-			</File>
-			<File
-				RelativePath="..\src\OcclusionQuery.h">
-			</File>
-			<File
-				RelativePath=".\OspTree.cpp">
-			</File>
-			<File
-				RelativePath=".\OspTree.h">
-			</File>
-			<File
-				RelativePath="..\src\Parser.h">
-			</File>
-			<File
-				RelativePath=".\Timer\PerfTimer.h">
-			</File>
-			<File
-				RelativePath=".\Timer\PerfTimerSkeleton.h">
-			</File>
-			<File
-				RelativePath="..\src\Plane3.cpp">
-			</File>
-			<File
-				RelativePath="..\src\Plane3.h">
-			</File>
-			<File
-				RelativePath="..\src\ply.h">
-			</File>
-			<File
-				RelativePath="..\src\plyfile.c">
-			</File>
-			<File
-				RelativePath="..\src\PlyParser.cpp">
-			</File>
-			<File
-				RelativePath="..\src\PlyParser.h">
-			</File>
-			<File
-				RelativePath="..\src\Polygon3.cpp">
-			</File>
-			<File
-				RelativePath="..\src\Polygon3.h">
-			</File>
-			<File
-				RelativePath="..\src\Polytope.cpp">
-			</File>
-			<File
-				RelativePath="..\src\Polytope.h">
-			</File>
-			<File
-				RelativePath="..\src\Preprocessor.cpp">
-			</File>
-			<File
-				RelativePath="..\src\Preprocessor.h">
+			UniqueIdentifier="{4FC737F1-C7A5-4376-A066-2A32D752A2FF}"
+			>
+			<File
+				RelativePath="..\src\AxisAlignedBox3.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\AxisAlignedBox3.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\Beam.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\Beam.h"
+				>
+			</File>
+			<File
+				RelativePath=".\Timer\BenchTimer.cpp"
+				>
+			</File>
+			<File
+				RelativePath=".\Timer\BenchTimer.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\BoostPreprocessorThread.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\BoostPreprocessorThread.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\BoundingBoxConverter.h"
+				>
+			</File>
+			<File
+				RelativePath=".\BvHierarchy.cpp"
+				>
+			</File>
+			<File
+				RelativePath=".\BvHierarchy.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\Camera.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\Camera.h"
+				>
+			</File>
+			<File
+				RelativePath=".\CombinedPreprocessor.cpp"
+				>
+			</File>
+			<File
+				RelativePath=".\CombinedPreprocessor.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\common.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\common.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\Containers.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\dual_depth.cg"
+				>
+			</File>
+			<File
+				RelativePath="..\src\Environment.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\Environment.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\ExactPreprocessor.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\ExactPreprocessor.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\Exporter.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\Exporter.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\FlexibleHeap.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\glInterface.h"
+				>
+			</File>
+			<File
+				RelativePath=".\GlobalLinesRenderer.cpp"
+				>
+			</File>
+			<File
+				RelativePath=".\GlobalLinesRenderer.h"
+				>
+			</File>
+			<File
+				RelativePath=".\GvsPreprocessor.cpp"
+				>
+			</File>
+			<File
+				RelativePath=".\GvsPreprocessor.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\GzBinFileInputStream.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\GzBinFileInputStream.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\GzFileInputSource.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\GzFileInputSource.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\gzstream.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\gzstream.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\Halton.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\Halton.h"
+				>
+			</File>
+			<File
+				RelativePath=".\HierarchyManager.cpp"
+				>
+			</File>
+			<File
+				RelativePath=".\HierarchyManager.h"
+				>
+			</File>
+			<File
+				RelativePath=".\IntelRayCaster.cpp"
+				>
+			</File>
+			<File
+				RelativePath=".\IntelRayCaster.h"
+				>
+			</File>
+			<File
+				RelativePath=".\InternalRayCaster.cpp"
+				>
+			</File>
+			<File
+				RelativePath=".\InternalRayCaster.h"
+				>
+			</File>
+			<File
+				RelativePath=".\Intersectable.cpp"
+				>
+			</File>
+			<File
+				RelativePath=".\Intersectable.h"
+				>
+			</File>
+			<File
+				RelativePath=".\IntersectableWrapper.cpp"
+				>
+			</File>
+			<File
+				RelativePath=".\IntersectableWrapper.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\KdTree.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\KdTree.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\LogManager.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\LogManager.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\Material.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\Material.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\Matrix4x4.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\Matrix4x4.h"
+				>
+			</File>
+			<File
+				RelativePath=".\Timer\merror.cpp"
+				>
+			</File>
+			<File
+				RelativePath=".\Timer\merror.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\Mesh.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\Mesh.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\MeshKdTree.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\MeshKdTree.h"
+				>
+			</File>
+			<File
+				RelativePath=".\Timer\mstring.h"
+				>
+			</File>
+			<File
+				RelativePath=".\Mutation.cpp"
+				>
+			</File>
+			<File
+				RelativePath=".\Mutation.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\MutualVisibility.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\MutualVisibility.h"
+				>
+			</File>
+			<File
+				RelativePath=".\ObjExporter.cpp"
+				>
+			</File>
+			<File
+				RelativePath=".\ObjExporter.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\ObjParser.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\ObjParser.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\OcclusionQuery.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\OcclusionQuery.h"
+				>
+			</File>
+			<File
+				RelativePath=".\OspTree.cpp"
+				>
+			</File>
+			<File
+				RelativePath=".\OspTree.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\Parser.h"
+				>
+			</File>
+			<File
+				RelativePath=".\Timer\PerfTimer.h"
+				>
+			</File>
+			<File
+				RelativePath=".\Timer\PerfTimerSkeleton.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\Plane3.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\Plane3.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\ply.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\plyfile.c"
+				>
+			</File>
+			<File
+				RelativePath="..\src\PlyParser.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\PlyParser.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\Polygon3.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\Polygon3.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\Polytope.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\Polytope.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\Preprocessor.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\Preprocessor.h"
+				>
 				<FileConfiguration
-					Name="Release|Win32">
+					Name="Release|Win32"
+					>
 					<Tool
 						Name="VCCustomBuildTool"
 						Description=""
 						CommandLine=""
-						Outputs=""/>
+						Outputs=""
+					/>
 				</FileConfiguration>
 				<FileConfiguration
-					Name="mlrt|Win32">
+					Name="mlrt|Win32"
+					>
 					<Tool
 						Name="VCCustomBuildTool"
 						Description=""
 						CommandLine=""
-						Outputs=""/>
+						Outputs=""
+					/>
 				</FileConfiguration>
 				<FileConfiguration
-					Name="Release_Internal|Win32">
+					Name="Release_Internal|Win32"
+					>
 					<Tool
 						Name="VCCustomBuildTool"
 						Description=""
 						CommandLine=""
-						Outputs=""/>
+						Outputs=""
+					/>
 				</FileConfiguration>
 				<FileConfiguration
-					Name="Release Internal|Win32">
+					Name="Release Internal|Win32"
+					>
 					<Tool
 						Name="VCCustomBuildTool"
 						Description=""
 						CommandLine=""
-						Outputs=""/>
+						Outputs=""
+					/>
 				</FileConfiguration>
 				<FileConfiguration
-					Name="release_noqt|Win32">
+					Name="release_noqt|Win32"
+					>
 					<Tool
 						Name="VCCustomBuildTool"
 						Description=""
 						CommandLine=""
-						Outputs=""/>
+						Outputs=""
+					/>
 				</FileConfiguration>
 				<FileConfiguration
-					Name="Release_Qt|Win32">
+					Name="Release_Qt|Win32"
+					>
 					<Tool
 						Name="VCCustomBuildTool"
 						Description=""
 						CommandLine=""
-						Outputs=""/>
+						Outputs=""
+					/>
 				</FileConfiguration>
 			</File>
 			<File
-				RelativePath=".\PreprocessorFactory.cpp">
-			</File>
-			<File
-				RelativePath=".\PreprocessorFactory.h">
-			</File>
-			<File
-				RelativePath="..\src\PreprocessorThread.cpp">
-			</File>
-			<File
-				RelativePath="..\src\PreprocessorThread.h">
+				RelativePath=".\PreprocessorFactory.cpp"
+				>
+			</File>
+			<File
+				RelativePath=".\PreprocessorFactory.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\PreprocessorThread.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\PreprocessorThread.h"
+				>
 				<FileConfiguration
-					Name="Release|Win32">
+					Name="Release|Win32"
+					>
 					<Tool
 						Name="VCCustomBuildTool"
 						Description=""
 						CommandLine=""
-						Outputs=""/>
+						Outputs=""
+					/>
 				</FileConfiguration>
 				<FileConfiguration
-					Name="mlrt|Win32">
+					Name="mlrt|Win32"
+					>
 					<Tool
 						Name="VCCustomBuildTool"
 						Description=""
 						CommandLine=""
-						Outputs=""/>
+						Outputs=""
+					/>
 				</FileConfiguration>
 				<FileConfiguration
-					Name="Release_Internal|Win32">
+					Name="Release_Internal|Win32"
+					>
 					<Tool
 						Name="VCCustomBuildTool"
 						Description=""
 						CommandLine=""
-						Outputs=""/>
+						Outputs=""
+					/>
 				</FileConfiguration>
 				<FileConfiguration
-					Name="Release Internal|Win32">
+					Name="Release Internal|Win32"
+					>
 					<Tool
 						Name="VCCustomBuildTool"
 						Description=""
 						CommandLine=""
-						Outputs=""/>
+						Outputs=""
+					/>
 				</FileConfiguration>
 				<FileConfiguration
-					Name="release_noqt|Win32">
+					Name="release_noqt|Win32"
+					>
 					<Tool
 						Name="VCCustomBuildTool"
 						Description=""
 						CommandLine=""
-						Outputs=""/>
+						Outputs=""
+					/>
 				</FileConfiguration>
 				<FileConfiguration
-					Name="Release_Qt|Win32">
+					Name="Release_Qt|Win32"
+					>
 					<Tool
 						Name="VCCustomBuildTool"
 						Description=""
 						CommandLine=""
-						Outputs=""/>
+						Outputs=""
+					/>
 				</FileConfiguration>
 			</File>
 			<File
-				RelativePath="..\src\Pvs.cpp">
-			</File>
-			<File
-				RelativePath="..\src\Pvs.h">
-			</File>
-			<File
-				RelativePath="..\src\Ray.cpp">
-			</File>
-			<File
-				RelativePath="..\src\Ray.h">
-			</File>
-			<File
-				RelativePath=".\RayCaster.cpp">
-			</File>
-			<File
-				RelativePath=".\RayCaster.h">
-			</File>
-			<File
-				RelativePath="..\src\RayInfo.cpp">
-			</File>
-			<File
-				RelativePath="..\src\RayInfo.h">
-			</File>
-			<File
-				RelativePath=".\Timer\RDTSCTimer.cpp">
-			</File>
-			<File
-				RelativePath=".\Timer\RDTSCTimer.h">
-			</File>
-			<File
-				RelativePath="..\src\Rectangle3.cpp">
-			</File>
-			<File
-				RelativePath="..\src\Rectangle3.h">
-			</File>
-			<File
-				RelativePath="..\src\RenderSampler.cpp">
-			</File>
-			<File
-				RelativePath="..\src\RenderSampler.h">
-			</File>
-			<File
-				RelativePath="..\src\RenderSimulator.cpp">
-			</File>
-			<File
-				RelativePath="..\src\RenderSimulator.h">
-			</File>
-			<File
-				RelativePath=".\RenderTexture.cpp">
-			</File>
-			<File
-				RelativePath=".\RenderTexture.h">
-			</File>
-			<File
-				RelativePath="..\src\ResourceManager.h">
-			</File>
-			<File
-				RelativePath="..\src\RssPreprocessor.cpp">
-			</File>
-			<File
-				RelativePath="..\src\RssPreprocessor.h">
-			</File>
-			<File
-				RelativePath="..\src\RssTree.cpp">
-			</File>
-			<File
-				RelativePath="..\src\RssTree.h">
-			</File>
-			<File
-				RelativePath="..\src\SamplingPreprocessor.cpp">
-			</File>
-			<File
-				RelativePath="..\src\SamplingPreprocessor.h">
-			</File>
-			<File
-				RelativePath="..\src\SamplingStrategy.cpp">
-			</File>
-			<File
-				RelativePath="..\src\SamplingStrategy.h">
-			</File>
-			<File
-				RelativePath="..\src\SceneGraph.cpp">
-			</File>
-			<File
-				RelativePath="..\src\SceneGraph.h">
-			</File>
-			<File
-				RelativePath="..\src\Statistics.h">
-			</File>
-			<File
-				RelativePath=".\SubdivisionCandidate.cpp">
-			</File>
-			<File
-				RelativePath=".\SubdivisionCandidate.h">
-			</File>
-			<File
-				RelativePath="..\src\Tetrahedron3.cpp">
-			</File>
-			<File
-				RelativePath="..\src\Tetrahedron3.h">
-			</File>
-			<File
-				RelativePath=".\Trackball.cpp">
-			</File>
-			<File
-				RelativePath=".\Trackball.h">
-			</File>
-			<File
-				RelativePath=".\TraversalTree.cpp">
-			</File>
-			<File
-				RelativePath=".\TraversalTree.h">
-			</File>
-			<File
-				RelativePath="..\src\Triangle3.cpp">
-			</File>
-			<File
-				RelativePath="..\src\Triangle3.h">
-			</File>
-			<File
-				RelativePath="..\src\UnigraphicsParser.cpp">
-			</File>
-			<File
-				RelativePath="..\src\UnigraphicsParser.h">
-			</File>
-			<File
-				RelativePath="..\src\Vector3.cpp">
-			</File>
-			<File
-				RelativePath="..\src\Vector3.h">
-			</File>
-			<File
-				RelativePath="..\src\ViewCell.cpp">
-			</File>
-			<File
-				RelativePath="..\src\ViewCell.h">
-			</File>
-			<File
-				RelativePath="..\src\ViewCellBsp.cpp">
-			</File>
-			<File
-				RelativePath="..\src\ViewCellBsp.h">
-			</File>
-			<File
-				RelativePath="..\src\ViewCellsManager.cpp">
-			</File>
-			<File
-				RelativePath="..\src\ViewCellsManager.h">
-			</File>
-			<File
-				RelativePath="..\src\ViewCellsParser.cpp">
-			</File>
-			<File
-				RelativePath="..\src\ViewCellsParser.h">
-			</File>
-			<File
-				RelativePath="..\src\ViewCellsParserXerces.h">
-			</File>
-			<File
-				RelativePath="..\src\VrmlExporter.cpp">
-			</File>
-			<File
-				RelativePath="..\src\VrmlExporter.h">
-			</File>
-			<File
-				RelativePath="..\src\VspBspTree.cpp">
-			</File>
-			<File
-				RelativePath="..\src\VspBspTree.h">
-			</File>
-			<File
-				RelativePath=".\VspTree.cpp">
-			</File>
-			<File
-				RelativePath=".\VspTree.h">
-			</File>
-			<File
-				RelativePath="..\src\VssPreprocessor.cpp">
-			</File>
-			<File
-				RelativePath="..\src\VssPreprocessor.h">
-			</File>
-			<File
-				RelativePath="..\src\VssRay.cpp">
-			</File>
-			<File
-				RelativePath="..\src\VssRay.h">
-			</File>
-			<File
-				RelativePath="..\src\VssTree.cpp">
-			</File>
-			<File
-				RelativePath="..\src\VssTree.h">
-			</File>
-			<File
-				RelativePath="..\src\X3dExporter.cpp">
-			</File>
-			<File
-				RelativePath="..\src\X3dExporter.h">
-			</File>
-			<File
-				RelativePath="..\src\X3dParser.cpp">
-			</File>
-			<File
-				RelativePath="..\src\X3dParser.h">
+				RelativePath="..\src\Pvs.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\Pvs.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\Ray.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\Ray.h"
+				>
+			</File>
+			<File
+				RelativePath=".\RayCaster.cpp"
+				>
+			</File>
+			<File
+				RelativePath=".\RayCaster.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\RayInfo.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\RayInfo.h"
+				>
+			</File>
+			<File
+				RelativePath=".\Timer\RDTSCTimer.cpp"
+				>
+			</File>
+			<File
+				RelativePath=".\Timer\RDTSCTimer.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\Rectangle3.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\Rectangle3.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\RenderSampler.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\RenderSampler.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\RenderSimulator.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\RenderSimulator.h"
+				>
+			</File>
+			<File
+				RelativePath=".\RenderTexture.cpp"
+				>
+			</File>
+			<File
+				RelativePath=".\RenderTexture.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\ResourceManager.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\RssPreprocessor.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\RssPreprocessor.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\RssTree.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\RssTree.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\SamplingPreprocessor.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\SamplingPreprocessor.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\SamplingStrategy.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\SamplingStrategy.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\SceneGraph.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\SceneGraph.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\Statistics.h"
+				>
+			</File>
+			<File
+				RelativePath=".\SubdivisionCandidate.cpp"
+				>
+			</File>
+			<File
+				RelativePath=".\SubdivisionCandidate.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\Tetrahedron3.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\Tetrahedron3.h"
+				>
+			</File>
+			<File
+				RelativePath=".\Trackball.cpp"
+				>
+			</File>
+			<File
+				RelativePath=".\Trackball.h"
+				>
+			</File>
+			<File
+				RelativePath=".\TraversalTree.cpp"
+				>
+			</File>
+			<File
+				RelativePath=".\TraversalTree.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\Triangle3.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\Triangle3.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\UnigraphicsParser.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\UnigraphicsParser.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\Vector3.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\Vector3.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\ViewCell.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\ViewCell.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\ViewCellBsp.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\ViewCellBsp.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\ViewCellsManager.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\ViewCellsManager.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\ViewCellsParser.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\ViewCellsParser.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\ViewCellsParserXerces.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\VrmlExporter.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\VrmlExporter.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\VspBspTree.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\VspBspTree.h"
+				>
+			</File>
+			<File
+				RelativePath=".\VspTree.cpp"
+				>
+			</File>
+			<File
+				RelativePath=".\VspTree.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\VssPreprocessor.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\VssPreprocessor.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\VssRay.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\VssRay.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\VssTree.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\VssTree.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\X3dExporter.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\X3dExporter.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\X3dParser.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\X3dParser.h"
+				>
 			</File>
 		</Filter>
@@ -956,60 +1296,78 @@
 			Name="Header Files"
 			Filter="h;hpp;hxx;hm;inl;inc;xsd"
-			UniqueIdentifier="{93995380-89BD-4b04-88EB-625FBE52EBFB}">
-			<File
-				RelativePath="..\include\AxisAlignedBox3.h">
-			</File>
-			<File
-				RelativePath="..\include\Containers.h">
-			</File>
-			<File
-				RelativePath="..\include\ExactPreprocessor.h">
-			</File>
-			<File
-				RelativePath="..\include\KdTree.h">
-			</File>
-			<File
-				RelativePath="..\include\Mesh.h">
-			</File>
-			<File
-				RelativePath="..\include\Plane3.h">
-			</File>
-			<File
-				RelativePath="..\include\Preprocessor.h">
-			</File>
-			<File
-				RelativePath="..\include\SamplingPreprocessor.h">
-			</File>
-			<File
-				RelativePath="..\include\SceneGraph.h">
-			</File>
-			<File
-				RelativePath="..\include\Vector3.h">
-			</File>
-			<File
-				RelativePath="..\include\ViewCell.h">
-			</File>
-			<File
-				RelativePath="..\src\X3dParserXerces.h">
+			UniqueIdentifier="{93995380-89BD-4b04-88EB-625FBE52EBFB}"
+			>
+			<File
+				RelativePath="..\include\AxisAlignedBox3.h"
+				>
+			</File>
+			<File
+				RelativePath="..\include\Containers.h"
+				>
+			</File>
+			<File
+				RelativePath="..\include\ExactPreprocessor.h"
+				>
+			</File>
+			<File
+				RelativePath="..\include\KdTree.h"
+				>
+			</File>
+			<File
+				RelativePath="..\include\Mesh.h"
+				>
+			</File>
+			<File
+				RelativePath="..\include\Plane3.h"
+				>
+			</File>
+			<File
+				RelativePath="..\include\Preprocessor.h"
+				>
+			</File>
+			<File
+				RelativePath="..\include\SamplingPreprocessor.h"
+				>
+			</File>
+			<File
+				RelativePath="..\include\SceneGraph.h"
+				>
+			</File>
+			<File
+				RelativePath="..\include\Vector3.h"
+				>
+			</File>
+			<File
+				RelativePath="..\include\ViewCell.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\X3dParserXerces.h"
+				>
 			</File>
 		</Filter>
 		<Filter
 			Name="Renderer"
-			Filter="">
-			<File
-				RelativePath="..\src\GlRenderer.cpp">
-			</File>
-			<File
-				RelativePath="..\src\GlRenderer.h">
-			</File>
-			<File
-				RelativePath="..\src\Renderer.cpp">
-			</File>
-			<File
-				RelativePath="..\src\Renderer.h">
+			>
+			<File
+				RelativePath="..\src\GlRenderer.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\GlRenderer.h"
+				>
+			</File>
+			<File
+				RelativePath="..\src\Renderer.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\src\Renderer.h"
+				>
 			</File>
 		</Filter>
 		<File
-			RelativePath=".\VTune\Preprocessor.vpj">
+			RelativePath=".\VTune\Preprocessor.vpj"
+			>
 		</File>
 	</Files>
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/run_test_arena
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/run_test_arena	(revision 2046)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/run_test_arena	(revision 2077)
@@ -2,5 +2,5 @@
 
 #COMMAND="./release/preprocessor.exe -preprocessor_quit_on_finish+"
-COMMAND="../scripts/preprocessor.sh -preprocessor_quit_on_finish+ -preprocessor_use_gl_renderer- -preprocessor_evaluate_filter- -preprocessor_detect_empty_viewspace+ -total_samples=500000000"
+COMMAND="../scripts/preprocessor.sh -preprocessor_quit_on_finish+ -preprocessor_use_gl_renderer- -preprocessor_evaluate_filter- -preprocessor_detect_empty_viewspace+ -samples_per_evaluation=5000000 -samples_per_pass=1000000 -total_samples=250000000 -view_cells_use_kd_pvs+"
 
 
@@ -8,37 +8,307 @@
 VIEWCELLS=../data/Arena/viewcells-5000.xml.gz
 
-PREFIX=../work/plots/osp-arena2-1e5
-
-# $COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
-#  -rss_distributions=mutation+object_direction+spatial -view_cells_filter_max_size=1 \
-#  -preprocessor_visibility_file=$PREFIX-i-mixed-b1-n4a.xml \
-#  -preprocessor_stats=$PREFIX-i-mixed-b1-n4a.log \
-#  -preprocessor_histogram_file=$PREFIX-i-mixed-b1-n4a.hlog
-
-# # n - no origin mutation, q=2, reverse samples
+PREFIX=../work/plots/osp-arena3
+
+
+###########################
+###########################
 
 $COMMAND -preprocessor=sampling -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
--total_samples=500000000000 -total_time=12208 \
--preprocessor_visibility_file=$PREFIX-r-reference.xml \
+-preprocessor_visibility_file=$PREFIX-reference.xml \
 -view_cells_filter_max_size=1 -preprocessor_stats=$PREFIX-r-reference.log \
 -preprocessor_histogram_file=$PREFIX-r-reference.hlog
 
 $COMMAND -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
- -total_samples=500000000000 -total_time=12208 \
  -rss_distributions=direction -view_cells_filter_max_size=1 \
  -preprocessor_visibility_file=$PREFIX-r-reference-global.xml \
- -preprocessor_stats=$PREFIX-r-reference-global.log \
+ -preprocessor_stats=$PREFIX-reference-global.log \
  -preprocessor_histogram_file=$PREFIX-r-reference-global.hlog
 
-#mutation+object_direction+
-
-# BVH
-
-
-# $COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
-#  -rss_distributions=mutation+object_direction+spatial \
-#  -view_cells_use_kd_pvs- -af_use_kd_pvs- \
-#  -preprocessor_visibility_file=$PREFIX-i-mixed-bvh-n4n.xml \
-#  -preprocessor_stats=$PREFIX-i-mixed-bvh-n4n.log \
-#  -preprocessor_histogram_file=$PREFIX-i-mixed-bvh-n4n.hlog
-
+$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-mutation_buffer_size=100000 \
+-rss_distributions=mutation+object_direction+spatial \
+-preprocessor_stats=$PREFIX-combined-m1-1.log 
+
+$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-mutation_buffer_size=200000 \
+-rss_distributions=mutation+object_direction+spatial \
+-preprocessor_stats=$PREFIX-combined-m1-2.log 
+
+$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-mutation_buffer_size=500000 \
+-rss_distributions=mutation+object_direction+spatial \
+-preprocessor_stats=$PREFIX-combined-m1-3.log 
+
+$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-mutation_buffer_size=1000000 \
+-rss_distributions=mutation+object_direction+spatial \
+-preprocessor_stats=$PREFIX-combined-m1-4.log 
+
+$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-mutation_buffer_size=2000000 \
+-rss_distributions=mutation+object_direction+spatial \
+-preprocessor_stats=$PREFIX-combined-m1-5.log 
+
+$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-mutation_buffer_size=4000000 \
+-rss_distributions=mutation+object_direction+spatial \
+-preprocessor_stats=$PREFIX-combined-m1-6.log 
+
+
+# ############################
+# #### AND now the same with pass importance off
+
+$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-mutation_use_pass_importance- \
+-mutation_buffer_size=100000 \
+-rss_distributions=mutation+object_direction+spatial \
+-preprocessor_stats=$PREFIX-combined-m2-1.log 
+
+$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-mutation_use_pass_importance- \
+-mutation_buffer_size=200000 \
+-rss_distributions=mutation+object_direction+spatial \
+-preprocessor_stats=$PREFIX-combined-m2-2.log 
+
+$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-mutation_use_pass_importance- \
+-mutation_buffer_size=500000 \
+-rss_distributions=mutation+object_direction+spatial \
+-preprocessor_stats=$PREFIX-combined-m2-3.log 
+
+$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-mutation_use_pass_importance- \
+-mutation_buffer_size=1000000 \
+-rss_distributions=mutation+object_direction+spatial \
+-preprocessor_stats=$PREFIX-combined-m2-4.log 
+
+$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-mutation_use_pass_importance- \
+-mutation_buffer_size=2000000 \
+-rss_distributions=mutation+object_direction+spatial \
+-preprocessor_stats=$PREFIX-combined-m2-5.log 
+
+$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-mutation_use_pass_importance- \
+-mutation_buffer_size=4000000 \
+-rss_distributions=mutation+object_direction+spatial \
+-preprocessor_stats=$PREFIX-combined-m2-6.log 
+
+# ################################################
+# # silhouetee probability test
+# ################################################
+
+$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-mutation_silhouette_prob=0.0 \
+-mutation_use_pass_importance- \
+-mutation_buffer_size=500000 \
+-rss_distributions=mutation+object_direction+spatial \
+-preprocessor_stats=$PREFIX-combined-m3-1.log 
+
+$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-mutation_silhouette_prob=0.2 \
+-mutation_use_pass_importance- \
+-mutation_buffer_size=500000 \
+-rss_distributions=mutation+object_direction+spatial \
+-preprocessor_stats=$PREFIX-combined-m3-2.log 
+
+$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-mutation_silhouette_prob=0.5 \
+-mutation_use_pass_importance- \
+-mutation_buffer_size=500000 \
+-rss_distributions=mutation+object_direction+spatial \
+-preprocessor_stats=$PREFIX-combined-m3-3.log 
+
+$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-mutation_silhouette_prob=0.8 \
+-mutation_use_pass_importance- \
+-mutation_buffer_size=500000 \
+-rss_distributions=mutation+object_direction+spatial \
+-preprocessor_stats=$PREFIX-combined-m3-4.log 
+
+$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-mutation_silhouette_prob=1.0 \
+-mutation_use_pass_importance- \
+-mutation_buffer_size=500000 \
+-rss_distributions=mutation+object_direction+spatial \
+-preprocessor_stats=$PREFIX-combined-m3-5.log 
+
+
+################################################
+# reverse test
+################################################
+
+$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-mutation_reverse_samples_distance=1.0 \
+-mutation_use_pass_importance- \
+-mutation_buffer_size=500000 \
+-rss_distributions=mutation+object_direction+spatial \
+-preprocessor_stats=$PREFIX-combined-m4-1.log 
+
+
+$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-mutation_reverse_samples_distance=100000.0 \
+-mutation_use_pass_importance- \
+-mutation_buffer_size=500000 \
+-rss_distributions=mutation+object_direction+spatial \
+-preprocessor_stats=$PREFIX-combined-m4-2.log 
+
+
+### unsucc count test
+
+
+
+$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-mutation_use_unsucc_count_importance+ \
+-mutation_use_pass_importance- \
+-mutation_buffer_size=2000000 \
+-rss_distributions=mutation+object_direction+spatial \
+-preprocessor_stats=$PREFIX-combined-m5-1.log 
+
+
+$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-mutation_use_unsucc_count_importance+ \
+-mutation_use_pass_importance- \
+-mutation_buffer_size=500000 \
+-rss_distributions=mutation+object_direction+spatial \
+-preprocessor_stats=$PREFIX-combined-m5-2.log 
+
+
+###########################################
+# search steps test
+###########################################
+
+$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-mutation_silhouette_search_steps=1 \
+-mutation_buffer_size=500000 \
+-rss_distributions=mutation+object_direction+spatial \
+-preprocessor_stats=$PREFIX-combined-m6-1.log 
+
+$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-mutation_silhouette_search_steps=2 \
+-mutation_buffer_size=500000 \
+-rss_distributions=mutation+object_direction+spatial \
+-preprocessor_stats=$PREFIX-combined-m6-2.log 
+
+$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-mutation_silhouette_search_steps=4 \
+-mutation_buffer_size=500000 \
+-rss_distributions=mutation+object_direction+spatial \
+-preprocessor_stats=$PREFIX-combined-m6-3.log 
+
+
+###########################################
+# radius test
+###########################################
+
+$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-mutation_radius_origin=0.2 \
+-mutation_radius_termination=0.2 \
+-mutation_silhouette_prob=0.5 \
+-mutation_use_pass_importance- \
+-mutation_buffer_size=500000 \
+-rss_distributions=mutation+object_direction+spatial \
+-preprocessor_stats=$PREFIX-combined-m7-1.log 
+
+$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-mutation_radius_origin=1.0 \
+-mutation_radius_termination=1.0 \
+-mutation_silhouette_prob=0.5 \
+-mutation_use_pass_importance- \
+-mutation_buffer_size=500000 \
+-rss_distributions=mutation+object_direction+spatial \
+-preprocessor_stats=$PREFIX-combined-m7-2.log 
+
+$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-mutation_radius_origin=0.5 \
+-mutation_radius_termination=0.2 \
+-mutation_silhouette_prob=0.5 \
+-mutation_use_pass_importance- \
+-mutation_buffer_size=500000 \
+-rss_distributions=mutation+object_direction+spatial \
+-preprocessor_stats=$PREFIX-combined-m7-3.log 
+
+$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-mutation_radius_origin=0.5 \
+-mutation_radius_termination=1.0 \
+-mutation_silhouette_prob=0.5 \
+-mutation_use_pass_importance- \
+-mutation_buffer_size=500000 \
+-rss_distributions=mutation+object_direction+spatial \
+-preprocessor_stats=$PREFIX-combined-m7-4.log 
+
+$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-mutation_radius_origin=0.2 \
+-mutation_radius_termination=0.5 \
+-mutation_silhouette_prob=0.5 \
+-mutation_use_pass_importance- \
+-mutation_buffer_size=500000 \
+-rss_distributions=mutation+object_direction+spatial \
+-preprocessor_stats=$PREFIX-combined-m7-5.log 
+
+
+$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-mutation_radius_origin=1.0 \
+-mutation_radius_termination=0.5 \
+-mutation_silhouette_prob=0.5 \
+-mutation_use_pass_importance- \
+-mutation_buffer_size=500000 \
+-rss_distributions=mutation+object_direction+spatial \
+-preprocessor_stats=$PREFIX-combined-m7-6.log 
+
+$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-mutation_radius_origin=2.0 \
+-mutation_radius_termination=0.5 \
+-mutation_silhouette_prob=0.5 \
+-mutation_use_pass_importance- \
+-mutation_buffer_size=500000 \
+-rss_distributions=mutation+object_direction+spatial \
+-preprocessor_stats=$PREFIX-combined-m7-7.log 
+
+
+### selected tests
+
+
+$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-mutation_silhouette_prob=0.5 \
+-mutation_reverse_samples_distance=1.0 \
+-mutation_radius_origin=0.5 \
+-mutation_radius_termination=0.2 \
+-mutation_use_unsucc_count_importance+ \
+-mutation_use_pass_importance- \
+-mutation_buffer_size=2000000 \
+-rss_distributions=mutation+object_direction+spatial \
+-preprocessor_stats=$PREFIX-combined-m8-1.log 
+
+$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-mutation_silhouette_prob=0.5 \
+-mutation_reverse_samples_distance=1.0 \
+-mutation_radius_origin=1.0 \
+-mutation_radius_termination=0.2 \
+-mutation_use_unsucc_count_importance+ \
+-mutation_use_pass_importance- \
+-mutation_buffer_size=2000000 \
+-rss_distributions=mutation+object_direction+spatial \
+-preprocessor_stats=$PREFIX-combined-m8-2.log 
+
+$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-mutation_silhouette_prob=0.5 \
+-mutation_reverse_samples_distance=1.0 \
+-mutation_radius_origin=2.0 \
+-mutation_radius_termination=0.2 \
+-mutation_use_unsucc_count_importance+ \
+-mutation_use_pass_importance- \
+-mutation_buffer_size=2000000 \
+-rss_distributions=mutation+object_direction+spatial \
+-preprocessor_stats=$PREFIX-combined-m8-3.log 
+
+$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-mutation_silhouette_prob=0.5 \
+-mutation_reverse_samples_distance=1.0 \
+-mutation_radius_origin=0.5 \
+-mutation_radius_termination=0.2 \
+-mutation_use_unsucc_count_importance- \
+-mutation_use_pass_importance+ \
+-mutation_buffer_size=2000000 \
+-rss_distributions=mutation+object_direction+spatial \
+-preprocessor_stats=$PREFIX-combined-m8-4.log 
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Pvs.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Pvs.h	(revision 2071)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Pvs.h	(revision 2077)
@@ -639,9 +639,10 @@
 {
 	bool found = false;
-
+	
 	PvsEntry<T, S> dummy(sample, PvsData());
 
 	// only check clean part
 	vector<PvsEntry<T, S> >::iterator sorted_end = mEntries.begin() + mLastSorted;
+	mQueriesSinceSort++;
 
 	// binary search
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/IntelRayCaster.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/IntelRayCaster.cpp	(revision 2076)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/IntelRayCaster.cpp	(revision 2077)
@@ -260,5 +260,4 @@
 						 const bool pruneInvalidRays )
 {
-  cout<<"INTEL"<<endl;
 
   int buckets = rays.size()/16;
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Makefile
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Makefile	(revision 2076)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Makefile	(revision 2077)
@@ -1,5 +1,5 @@
 #############################################################################
 # Makefile for building: preprocessor
-# Generated by qmake (2.00a) (Qt 4.1.2) on: pá 2. II 13:23:45 2007
+# Generated by qmake (2.00a) (Qt 4.1.2) on: pá 2. II 14:36:11 2007
 # Project:  preprocessor.pro
 # Template: app
